https://leetcode.com/problems/expressive-words/solution/
https://leetcode.com/problems/expressive-words/discuss/122660/C%2B%2BJavaPython-2-Pointers-and-4-pointers
https://leetcode.com/problems/expressive-words/discuss/122521/15-lines-java-code-2-pointers-1-pass.
list all cases/examples we need handle:
Use the different cases/examples to understand the problem
write main steps
separate to independent functions
Sometimes people repeat letters to represent extra feeling, such as "hello" -> "heeellooo", "hi" -> "hiiii". Here, we have groups, of adjacent letters that are all the same character, and adjacent characters to the group are different. A group is extended if that group is length 3 or more, so "e" and "o" would be extended in the first example, and "i" would be extended in the second example. As another example, the groups of "abbcccaaaa" would be "a", "bb", "ccc", and "aaaa"; and "ccc" and "aaaa" are the extended groups of that string.
For some given string S, a query word is stretchy if it can be made to be equal to S by extending some groups. Formally, we are allowed to repeatedly choose a group (as defined above) of characters
c
, and add some number of the same character c
to it so that the length of the group is 3 or more. Note that we cannot extend a group of size one like "h" to a group of size two like "hh" - all extensions must leave the group extended - ie., at least 3 characters long.
Given a list of query words, return the number of words that are stretchy.
Example: Input: S = "heeellooo" words = ["hello", "hi", "helo"] Output: 1 Explanation: We can extend "e" and "o" in the word "hello" to get "heeellooo". We can't extend "helo" to get "heeellooo" because the group "ll" is not extended.
Notes:
0 <= len(S) <= 100
.0 <= len(words) <= 100
.0 <= len(words[i]) <= 100
.S
and all words inwords
consist only of lowercase letters
- Time Complexity: , where is the length of
words
(at least 1), and is the maximum length of a word. - Space Complexity: .
For some word, write the head character of every group, and the count of that group. For example, for
"abbcccddddaaaaa"
, we'll write the "key" of "abcda"
, and the "count" [1,2,3,4,5]
.
Let's see if a
word
is stretchy. Evidently, it needs to have the same key as S
.
Now, let's say we have individual counts
c1 = S.count[i]
and c2 = word.count[i]
.- If
c1 < c2
, then we can't make thei
th group ofword
equal to thei
th word ofS
by adding characters. - If
c1 >= 3
, then we can add letters to thei
th group ofword
to match thei
th group ofS
, as the latter is extended. - Else, if
c1 < 3
, then we must havec2 == c1
for thei
th groups ofword
andS
to match.
public int expressiveWords(String S, String[] words) {
RLE R = new RLE(S);
int ans = 0;
search: for (String word : words) {
RLE R2 = new RLE(word);
if (!R.key.equals(R2.key))
continue;
for (int i = 0; i < R.counts.size(); ++i) {
int c1 = R.counts.get(i);
int c2 = R2.counts.get(i);
if (c1 < 3 && c1 != c2 || c1 < c2)
continue search;
}
ans++;
}
return ans;
}
class RLE {
String key;
List<Integer> counts;
public RLE(String S) {
StringBuilder sb = new StringBuilder();
counts = new ArrayList();
char[] ca = S.toCharArray();
int N = ca.length;
int prev = -1;
for (int i = 0; i < N; ++i) {
if (i == N - 1 || ca[i] != ca[i + 1]) {
sb.append(ca[i]);
counts.add(i - prev);
prev = i;
}
}
key = sb.toString();
}
}
https://leetcode.com/problems/expressive-words/discuss/122660/C%2B%2BJavaPython-2-Pointers-and-4-pointers
Loop through all words.
check(string S, string W)
checks if W
is stretchy to S
.
In
check
function, use two pointer:- If
S[i] == W[j
,i++, j++
- If
S[i - 2] == S[i - 1] == S[i]
orS[i - 1] == S[i] == S[i + 1]
,i++
- return false
public int expressiveWords(String S, String[] words) {
int res = 0;
for (String W : words) if (check(S, W)) res++;
return res;
}
public boolean check(String S, String W) {
int n = S.length(), m = W.length(), j = 0;
for (int i = 0; i < n; i++)
if (j < m && S.charAt(i) == W.charAt(j)) j++;
else if (i > 1 && S.charAt(i) == S.charAt(i - 1) && S.charAt(i - 1) == S.charAt(i - 2));
else if (0 < i && i < n - 1 && S.charAt(i - 1) == S.charAt(i) && S.charAt(i) == S.charAt(i + 1));
else return false;
return j == m;
}
https://leetcode.com/problems/expressive-words/discuss/122521/15-lines-java-code-2-pointers-1-pass.
public int expressiveWords(String S, String[] words) {
int count = 0;
for (String w : words) {
int i, j; // S & w's pointers.
for (i = 0, j = 0; i < S.length(); ++i) {
if (j < w.length() && S.charAt(i) == w.charAt(j)) { // matches, w pointer j 1 step forward to move together with i.
++j;
}else if (i > 0 && S.charAt(i - 1) == S.charAt(i) && i + 1 < S.length() && S.charAt(i) == S.charAt(i + 1)) { // previous, current & next are same.
++i; // S pointer 1 step forward, attempt to traverse the repeated chars.
}else if (!(i > 1 && S.charAt(i) == S.charAt(i - 1) && S.charAt(i) == S.charAt(i - 2))) { // current & previous 2 are not same.
break; // No match.
}
}
if (i == S.length() && j == w.length()) { ++count; } // both pointers reach ends.
}
return count;
}
Another approach use 4 pointers, but will be much easier to undersand and debug.
public boolean check(String S, String W) {
int n = S.length(), m = W.length(), i = 0, j = 0;
for (int i2 = 0, j2 = 0; i < n && j < m; i = i2, j = j2) {
if (S.charAt(i) != W.charAt(j)) return false;
while (i2 < n && S.charAt(i2) == S.charAt(i)) i2++;
while (j2 < m && W.charAt(j2) == W.charAt(j)) j2++;
if (i2 - i != j2 - j && i2 - i < Math.max(3, j2 - j)) return false;
}
return i == n && j == m;
}
https://leetcode.com/problems/expressive-words/discuss/121706/Java-Solution-using-Two-Pointers-with-Detailed-Explanation
We have two pointers, use
Firstly, for
i
to scan S
, and use j
to scan each word
in words
.Firstly, for
S
and word
, we can calculate the length of the susbtrings which contains the repeated letters of the letter currently pointed by the two pointers, and get len1
and len2
.
The two letters currently pointed by the two pointers must be equal, otherwise the
word
is not stretchy, we return false. Then, if we find that len1
is smaller than 3, it means the letter cannot be extended, so len1
must equals to len2
, otherwise this word
is not stretchy. In the other case, if len1
equals to or larger than 3, we must have len1
smaller than len2
, otherwise there are not enough letters in S
to match the letters in word
.
Finally, if the
word
is stretchy, we need to guarantee that both of the two pointers has scanned the whole string. public int expressiveWords(String S, String[] words) {
if (S == null || words == null) {
return 0;
}
int count = 0;
for (String word : words) {
if (stretchy(S, word)) {
count++;
}
}
return count;
}
public boolean stretchy(String S, String word) {
if (word == null) {
return false;
}
int i = 0;
int j = 0;
while (i < S.length() && j < word.length()) {
if (S.charAt(i) == word.charAt(j)) {
int len1 = getRepeatedLength(S, i);
int len2 = getRepeatedLength(word, j);
if (len1 < 3 && len1 != len2 || len1 >= 3 && len1 < len2) {
return false;
}
i += len1;
j += len2;
} else {
return false;
}
}
return i == S.length() && j == word.length();
}
public int getRepeatedLength(String str, int i) {
int j = i;
while (j < str.length() && str.charAt(j) == str.charAt(i)) {
j++;
}
return j - i;
}
list all cases/examples we need handle:
Use the different cases/examples to understand the problem
write main steps
separate to independent functions
public int expressiveWords(String S, String[] words) {
int count = 0;
for (String word : words) {
if (isStretchy(S, word)) {
count++;
}
}
return count;
}
public class CharCount {
public final Character ch;
public final int count;
CharCount(Character ch, int count) {
this.ch = ch;
this.count = count;
}
@Override
public String toString() {
return "CharCount [ch=" + ch + ", count=" + count + "]";
}
}
private List<CharCount> splitToGroup(String word) {
List<CharCount> groups = new ArrayList<>();
int i = 0;
int count = 1;
Character prev = word.charAt(i);
while (i < word.length()) {
while (i < word.length()) {
if (word.charAt(i) == prev) {
count++;
} else {
groups.add(new CharCount(prev, count));
prev = word.charAt(i);
count = 0;
break;
}
i++;
}
}
groups.add(new CharCount(prev, count));
return groups;
}
private boolean isStretchy(String S, String word) {
List<CharCount> sgroups = splitToGroup(S), wordGroups = splitToGroup(word);
// System.out.println(sgroups);
// System.out.println(wordGroups);
if (sgroups.size() != wordGroups.size()) {
return false;
}
for (int i = 0; i < sgroups.size(); i++) {
if (sgroups.get(i).ch != wordGroups.get(i).ch)
return false;
int c1 = sgroups.get(i).count;
int c2 = wordGroups.get(i).count;
if (c1 < 3 && c1 != c2 || c1 < c2) {
return false;
} // this is not right,
// if (sgroups.get(i).count != wordGroups.get(i).count && sgroups.get(i).count <
// wordGroups.get(i).count + 2)
// return false;
// if (sgroups.get(i).count % wordGroups.get(i).count != 0)
// return false;
//
// int div = sgroups.get(i).count / wordGroups.get(i).count;
// if (div == 2)
// return false;
}
return true;
}